<script lang="ts">
	import queryString from "query-string"
	import { getContext } from "svelte"
	import { goto } from "$app/navigation"
	import { page, session } from "$app/stores"
	import { AUTH_CONTEXT_KEY } from "$lib/constants"
	import { userProfile } from "$lib/stores"
	import ProjectLoader from "$lib/components/ProjectLoader.svelte"
	import ProjectSelector from "$lib/components/ProjectSelector.svelte"
	import DataPackageForm from "$lib/components/DataPackageForm.svelte"
	import { browser } from "$app/env"
	import type { Project } from "$lib/storage"
	import { CreateProjectError, CreateProjectDuplicateError } from "$lib/errors"

	let createError
	let errorMessage = null
	let storageAdapter

	let selectedProject: Project | null = null
	let filteredFiles: Array<string> = []
	let name: string = ""

	let nameError: string = ""

	const { gotoLoginIfAnonymous, tokens } = getContext(AUTH_CONTEXT_KEY)
	gotoLoginIfAnonymous($page)
	$: if (browser && $tokens && $userProfile) {
		fetchInitialData($session, $tokens, $userProfile)
	}

	async function fetchInitialData(session, tokens, userProfile) {
		const GitLabStorageAdapter = (await import("$lib/infrastructure/storage-adapter/gitlab")).default
		storageAdapter = GitLabStorageAdapter.create(session.config, tokens, userProfile)
	}

	async function handleSubmit(event) {
		const formData = event.detail
		const datapackageName = formData.get("datapackage-name")
		if (storageAdapter === null || !datapackageName) {
			return
		}
		let project = null
		if (selectedProject === null) {
			try {
				project = await storageAdapter.createProject(datapackageName)
			} catch (error) {
				if (error instanceof CreateProjectDuplicateError) {
					nameError = "A project with the same name already exists, please choose another name"
				} else if (error instanceof CreateProjectError) {
					nameError = "Invalid name, please choose another name"
				} else {
					throw error
				}
				const errorMessage = document.querySelector('div [name="datapackage-name"]')
				errorMessage.scrollIntoView()
				return
			}
		} else {
			project = selectedProject
		}
		let dataPackageCreated
		try {
			dataPackageCreated = await storageAdapter.createDataPackage(project, formData, filteredFiles)
		} catch (error) {
			console.error(error)
			createError = "Could not create data package"
		}
		if (dataPackageCreated) {
			goto(
				queryString.stringifyUrl({
					url: "/data-packages/view",
					query: {
						project: (project as Project).name,
					},
				})
			)
		}
	}

	function handleProjectSelect() {
		nameError = ""
	}
</script>

<nav aria-label="breadcrumb" class="mb-8">
	<ul class="breadcrumb p-2 rounded bg-gray-100">
		<li class="breadcrumb-item"><a href="/data-packages">Data Packages</a></li>
		<li class="breadcrumb-item" aria-current="page">New</li>
	</ul>
</nav>

<h1>New Data Package</h1>

{#if createError}
	<p>{createError}</p>
{:else if storageAdapter}
	<DataPackageForm {errorMessage} {selectedProject} bind:filteredFiles on:submit={handleSubmit} bind:name {nameError}>
		{#if !selectedProject && name}
			<p>automaticaly on a new project: '<span class="font-bold">{name}</span>'</p>
			<p><span class="font-bold">or</span> store data package on</p>
		{/if}
		<ProjectLoader {storageAdapter} projectFilter={{ onlyNoDataPackages: true }} let:projects>
			<ProjectSelector bind:selected={selectedProject} {projects} enableUnselect on:select={handleProjectSelect} />
		</ProjectLoader>
	</DataPackageForm>
{/if}
